import time
import sys
sys.path.append('C:\Users\credz\Desktop\Razor\Scripts')
import common
common.Player = Player
common.Target = Target
common.Items = Items
common.Mobiles = Mobiles
common.Misc = Misc
common.Journal = Journal
common.Statics = Statics
common.Gumps = Gumps
common.Spells = Spells
common.BandageHeal = BandageHeal
#
from System.Collections.Generic import List
from System import Byte, Int32
#
#
skillIds = List[Int32] (( 0x00D8, 0x00EA, 0x00E7, 0x00D4, 0x00DD, 0x00D5, 0x00E8, 0x00E9, 0x00BB, 0x00BC ))
#
def MoveToAnimal(animal):
    route = PathFinding.Route()
    route.X = animalToTame.Position.X-1
    route.Y = animalToTame.Position.Y-1
    route.MaxRetry = 5
    route.StopIfStuck = True
    Misc.SendMessage("Attempting to Go")
    result = PathFinding.Go(route)
    Misc.SendMessage("Go result is {}".format(result))
    if result:
        timeout = time.time() + 20
        while Player.DistanceTo(animal) > 1:
            Misc.SendMessage("trying to get there")
            if timeout > time.time():
                return False
            Misc.Pause(500)            
        return True    
    else:
        Player.HeadMessage(Player.Serial, "Unable to route")
        return False
#        
def StartTaming(animal):
    Journal.Clear()
    retry = True
    maxTime = time.time() + 10
    while retry:
        if time.time() > maxTime:
            return False
        Player.UseSkill("Animal Taming")
        Target.WaitForTarget(2000, False)
        Target.TargetExecute(animal)
        Misc.Pause(500)
        if Journal.Search("tame already"):
            Journal.Clear()
            retry = False
            return False
        if Journal.Search("too far away"):
            Journal.Clear()
            retry = True
        else:
            retry = False
    return True        
#    
def FollowAnimalWhileTaming(animal): 
    Journal.Clear()   
    taming = True
    while taming:
        if Player.DistanceTo(animal) > 3:
            if False == MoveToAnimal(animal):
                return False
        if Journal.Search("You fail to tame the creature"):
            return False
        if Journal.Search("seems to accept"):
            return True
        Misc.Pause(500)    
    
#
def DestroyAnimal(animal):
    Misc.PetRename(animal, "killme")
    Misc.Pause(500)
    Player.ChatSay(658, "killme release")
    Misc.Pause(500)
    Gumps.WaitForGump(2426193729, 5000)
    Gumps.SendAction(2426193729, 2)
    Misc.Pause(1000)
    Player.SetWarMode(True)
    Player.Attack(animal)
    while Mobiles.FindBySerial(animal.Serial):
        Misc.Pause(500)
    Player.SetWarMode(False)    
#
#
#
Misc.ClearIgnore()
moreToTame = True
while moreToTame:
    animalsToTame_filter =  Mobiles.Filter()
    animalsToTame_filter.Enabled = True
    animalsToTame_filter.Bodies = skillIds
    animalsToTame_filter.RangeMax = 30
    animalsToTame_filter.CheckIgnoreObject = True
    animalsToTame_list = Mobiles.ApplyFilter(animalsToTame_filter)
    animalToTame = Mobiles.Select(animalsToTame_list, "Nearest")
    if animalToTame == None:
        moreToTame = False
    else:
        continueTaming = True
        while continueTaming:
            startOk = StartTaming(animalToTame)
            if startOk == True:
                    tameResult = FollowAnimalWhileTaming(animalToTame)
                    if tameResult == True:
                        DestroyAnimal(animalToTame)    
                        continueTaming = False
                    else:
                        continueTaming = True
                else:
                    Misc.IgnoreObject(animalToTame)
                    continueTaming = False
    
